/*
This software is available under NYSL(Nirunari Yakunari Sukinishiro License).
*/

/*
 * MyeongWol Controller Firmware
 * by Bizan Nishimura
 */
 
/*GR-SAKURA Sketch Template Version: V1.02*/
#include <rxduino.h>
#include <servo.h>
#include "steppers.h"
#include "common.h"
#include "tkusbhost.h"
#include "usb_bt.h"
#include "bt_spp.h"

/**
 * T[{
 * [0]:Waist [1]:Neck [2]:Arm-L1 [3]:Arm-L2 [4]:Arm-R1 [5]:Arm-R2
 */
Servo servos[6];

/**
 * 
 */
void setup()
{
    // VAʐM̐ݒ
    /* IO0(P21):RxD, IO1(P20):TxD */
    Serial.begin(9600,SCI_SCI0P2x);
//    Serial.println("?");

    pinMode(PIN_LED0,OUTPUT);
    pinMode(PIN_LED1,OUTPUT);
    pinMode(PIN_LED2,OUTPUT);
    pinMode(PIN_LED3,OUTPUT);
    digitalWrite(PIN_LED0, 0);
    digitalWrite(PIN_LED1, 0);
    digitalWrite(PIN_LED2, 0);
    digitalWrite(PIN_LED3, 0);

    // XebsO[^̐ݒ
    // IO6:nEnable, IO5:L-Clk, IO4:L-Dir, IO3:R-Clk, IO2:R-Dir
    steppers_init(6,5,4,3,2);
    steppers_disable();
    //steppers_enable();
    steppers_stop();
    
    // T[{̐ݒ
    pinMode(7,OUTPUT); // IO7:Servo Enable (High Active)
    digitalWrite(7,  1);
    servos[0].attach(13); // IO13:Waist
    servos[1].attach(12); // IO12:Neck
    servos[2].attach(9);  // IO9:Arm-L1
    servos[3].attach(8);  // IO8:Arm-L2
    servos[4].attach(11); // IO11:Arm-R1
    servos[5].attach(10); // IO10:Arm-R2
    // T[{̏px
    servos[0].write(90);
    servos[1].write(90);
    servos[2].write(90);
    servos[3].write(90);
    servos[4].write(90);
    servos[5].write(90);
    
    delay(100);
//    Serial.println("?");
    delay(100);
//    Serial.println("konnichiwa");
    
    // USB̏
    if(tkusbh_init() != TKUSBH_OK)
    {
//        Serial.print("!!! USB Host Initialization ERROR !!! system halt\n");
        while(1);
    }
}


/**
 * MR}h̎s
 *
 * @param buff MR}hւ̃|C^
 */
extern "C" void execute_command(char* buff)
{
    // 012345678901234567890
    // AAABBBCCCDDDEEEFFFGH
    // AAA=Waist BBB=Neck CCC=Arm-L1 DDD=Arm-L2
    // EEE=Arm-R1 FFF=Arm-R2 G=[FBRLS] H=x(0-9)
    buff[20] = '\0';
    Serial.println(buff);
    
    // T[{6
    for(int servoNum=0; servoNum<6; servoNum++){
        unsigned short val;
        /* wߊpxL(180ȉ)Ȃݒ */
        if( DecToUint16(&buff[3*servoNum], &val, 3) == 0 )
        {
            if( val<=180 )
            {
                //Serial.println("DEG ");
                if(servoNum==3 || servoNum==4 || servoNum==5)
                {
                    val = 180 - val;
                }
                servos[servoNum].write(val);
            }
        }
    }
    
    // XebsO[^
    char dir = buff[18];
    unsigned short vel;
    if( DecToUint16(&buff[19], &vel, 1) != 0 ){
        vel = 0;
    }
    if(vel != 0) vel = 9 - vel;
    switch(dir){
    case 'F':
        steppers_enable();
        steppers_forward(vel);
        break;
    case 'B':
        steppers_enable();
        steppers_backward(vel);
        break;
    case 'R':
        steppers_enable();
        steppers_turnRight(vel);
        break;
    case 'L':
        steppers_enable();
        steppers_turnLeft(vel);
        break;
    default:
        steppers_stop();
        steppers_disable();
    }
}

/**
 * C[v
 */
void loop()
{
    /* USB^XN */
    usb_task();
    digitalWrite(PIN_LED2, 1);
    /* Bluetooth^XN */
    bt_task();
    digitalWrite(PIN_LED2, 0);
}


